/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

#include <sys/types.h>
#include <resource.h>

#include <sys/service.h>	/* FP macros */
#include <sys/process.h>	/* _pc */

#include "resutils.h"

/* =========================== */
/* Handle WonderWitch Resource */
/* =========================== */

res_t far *ww_find_next_resource(res_t far *res_p, WORD type, short id)
{
	/* K */
	res_p = MK_FP(FP_SEG(res_p) + (FP_OFF(res_p)>>4), FP_OFF(res_p) & 0x000f);

	/*  */
	while (res_p->magic == RESID) {
		if ((res_p->id != id) || (res_p->type != type)) {
			res_p = MK_FP(FP_SEG(res_p) + res_p->size, FP_OFF(res_p));
			continue;
		}
		res_p = MK_FP(FP_SEG(res_p) + (FP_OFF(res_p)>>4), FP_OFF(res_p) & 0x000f);
		return (void far *)res_p;
	}
	return NULL;
}

res_t far *ww_find_first_resource(WORD type, short id)
{
	return ww_find_next_resource(_pc->_resource, type, id);
}

char far *ww_find_bmp_resource(short id)
{
	res_t far *res_p;
	res_p = ww_find_next_resource(_pc->_resource, RESID_IMAGE, id);
	if (res_p == NULL) {
		return NULL;
	}

	res_p = MK_FP(FP_SEG(res_p), FP_OFF(res_p) + sizeof(res_image_t));
	res_p = MK_FP(FP_SEG(res_p) + (FP_OFF(res_p)>>4), FP_OFF(res_p) & 0x000f);

    return (char far *)res_p;
}
