/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

/*
 * http://wonderwitch.qute.co.jp/tips/index.html#key_hit_check_doesnt_work
 *
 * KEY_PRESS_CHECKKEY_HIT_CHECKAČĂł͂Ȃ
 *
 *   L[BIOS̋@\AKEY_PRESS_CHECKĂяoƁA FreyaBIOS̓[N
 *   GAɕێĂL[ԂXV܂B̃[NGAKEY_H
 *   IT_CHECKȂǁA̋@\łQƂ邽߁A KEY_PRESS_CHECKĂяo
 *   KEY_HIT_CHECKĂяoƁAʂ܂B
 *
 *   ́A{AKEY_PRESS_CHECK[NGAXVׂł͂Ȃ̂ɁAX
 *   VĂ܂Ă邱ƂɗRłÄӐۏ؂̊ϓ_珫
 *   IȑΉɂĂ݂͌̂Ƃ\肵Ă܂B
 *
 *   ʓIȉƂẮAKEY_PRESS_CHECK݂̂pKEY_HIT_CHECK̂
 *   ͎̂OŏƂƂɂȂ܂BႦ΁AAԊ荞(VBL
 *   ANK荞)̂тɈxKEY_PRESS_CHECKĂяoAʂÕ[
 *   NGAɕۑĂāAԂ̎擾͂̃[NGAQƂ܂B
 */

#include <sys/system.h>
#include <sys/timer.h>

#include <sys/process.h>
#include <sys/bank.h>

#include "wwhook.h"

#include "wwkey.h"

static unsigned short s_keypress;
static unsigned short s_keytrigger;

unsigned short ww_get_keypress()
{
	return s_keypress;
}

unsigned short ww_get_keytrigger()
{
	return s_keytrigger;
}

void ww_wait_keyrelease()
{
	while (ww_get_keypress()) {
		sys_wait(1);
	}
}

int ww_wait_keyhit()
{
	int key;
	while (ww_get_keypress()) {
		sys_wait(1);
	}
	for (;;) {
		key = ww_get_keypress();
		if (key) {
			 break;
		}
		sys_wait(1);
	}
	return key;
}

void static far keycheckcallback()
{
	unsigned short key;
	int oldbank = bank_get_map(BANK_SRAM);
	int proc_bank = pcb_get_srambank();

	key = key_press_check();

	bank_set_map(BANK_SRAM, proc_bank);

	s_keytrigger = key & (~s_keypress);
	s_keypress = key;

	bank_set_map(BANK_SRAM, oldbank);
}

int ww_init_key()
{
	static int callOnce = 0;

	if (callOnce == 0) {
		/* l */
		s_keytrigger = s_keypress = key_press_check();

		/*VBLANK荞݃tbNZbg*/
		ww_set_hook(SYS_INT_VBLANK_COUNTUP, keycheckcallback);

		/*VBLANK^C}[荞ݐݒ*/
		ww_enable_hook(TIMER_VBLANK);

		callOnce = 1;
	}

	return 0;
}
