/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

#include <sys/timer.h>
#include <sys/system.h>

#include <sys/process.h>
#include <sys/bank.h>

#include "wwhook.h"
#include "wwsync.h"

static volatile int hsync = 0;

void static far hb_callback()
{
#if 0
	int oldbank = bank_get_map(BANK_SRAM);
	int proc_bank = pcb_get_srambank();

	bank_set_map(BANK_SRAM, proc_bank);

	/* 荞݃nh̏{ */
	if (hsync < 511) {
		hsync++;
	}

	bank_set_map(BANK_SRAM, oldbank);
#else
	if (hsync < 511) {
		hsync++;
	}
#endif
}

int ww_sync_set_counter(int n)
{
	hsync = n;
	return 0;
}

int ww_sync_get_counter()
{
	return hsync;
}

void ww_sync_init()
{
	static int callOnce = 0;

	if (callOnce == 0) {
		/*HBLANK荞݃tbNZbg*/
		ww_set_hook(SYS_INT_HBLANK_COUNTUP, hb_callback);

		/*HBLANK^C}[荞ݐݒ*/
		ww_enable_hook(TIMER_HBLANK);

		callOnce = 1;
	}
}
